
// NumaExplorerDlg.h : header file
//

#pragma once
#include "afxwin.h"
#include "SystemLogicalProcessorInformationDisplay.h"
#include "NumaMemoryMap.h"
#include "Trace.h"
#include "nodemap.h"
#include "NodeMap.h"
#include "XMLDisplay.h"

class XMLNode;
class XMLTag;
// CNumaExplorerDlg dialog
class CNumaExplorerDlg : public CDialog
{
// Construction
public:
        CNumaExplorerDlg(CWnd* pParent = NULL); // standard constructor

// Dialog Data
        enum { IDD = IDD_NUMAEXPLORER_DIALOG };

        protected:
        virtual void DoDataExchange(CDataExchange* pDX);        // DDX/DDV support


// Implementation
protected:
        HICON m_hIcon;
        ULONG NumaHighestNodeNumber;
        DWORD NumberOfProcessors;
        DWORD PageSize;
        
        XMLNode * Data;

protected:
        void updateControls();
        void Refresh();
        void NumaAlloc(UINT Pages, XMLTag * VAEN);
        void DumpNumaNodeInfo(UCHAR Cpu, UCHAR Nodes, PVOID Buffer, SIZE_T Size, XMLTag * VAEN);
        void DumpRegion(UCHAR Cpu, UCHAR Nodes, PVOID StartPtr, PVOID EndPtr, DWORD Node, BOOL Valid, XMLTag * VAEN);
protected: // Generated message map functions
        virtual BOOL OnInitDialog();
        afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
        afx_msg void OnPaint();
        afx_msg HCURSOR OnQueryDragIcon();
        DECLARE_MESSAGE_MAP()
        virtual void OnOK();
        virtual void OnCancel();
        afx_msg void OnClose();
        afx_msg void OnSize(UINT nType, int cx, int cy);
        afx_msg void OnBnClickedRefresh();
        afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
        afx_msg void OnHelpAboutNumaExplorer();
        afx_msg void OnFileExit();
        afx_msg void OnEditClearLog();
        afx_msg void OnFileSaveXMLFile();
        afx_msg void OnFileLoadXMLFile();
        afx_msg void OnDestroy();
        afx_msg LRESULT OnQueryNode(WPARAM, LPARAM);
        afx_msg void OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu);
protected:
   CEdit c_NumaHighestNodeNumber;
   CComboBox c_SYSTEM_INFO;
   CListBox c_Numa;
   CListBox c_NumaNodeProcessorMask;
   CListBox c_NumaAvailableMemoryNode;
   CSystemLogicalProcessorInformationDisplay c_GLPI;
   CStatic c_Frame;
   CNumaMemoryMap c_NumaMemoryMap;
   CEdit c_Pages;
   CTraceList c_Log;
   CComboBox c_NodeInfo;
   CNodeMap c_NodeMap;
   CXMLDisplay c_XML;
};
